Imports System
Imports System.Diagnostics
Imports System.Management

Public Class MyProcess

Public Function GetParentProcessID(ByVal PID As Integer) As Integer
Dim Searcher As New ManagementObjectSearcher("SELECT * FROM Win32_Process WHERE ProcessID="&PID)
Dim Processes As ManagementObjectCollection=Searcher.Get()
If Processes.Count<>1 Then Err.Raise(9)
For Each Process As ManagementObject In Processes
  Return Process("ParentProcessID")
Next
End Function 'GetParentProcessID

Public Shared Function Main(ByVal Arguments() As String) As Integer
Try
Dim PID As Integer
If Arguments.Length=1 Then
  If IsNumeric(Arguments(0)) Then
    PID=System.Convert.ToInt32(Arguments(0))
  Else
    System.Console.Error.WriteLine("Usage: GetParentProcessID [PID]")
    Return 1
  End If
ElseIf Arguments.Length=0 Then
  PID=Process.GetCurrentProcess().Id
Else
  System.Console.Error.WriteLine("Usage: GetParentProcessID [PID]")
  Return 1
End If
Dim myProcess As New MyProcess()
System.Console.WriteLine(myProcess.GetParentProcessID(PID))
Catch
System.Console.Error.WriteLine("Source" & vbTab & vbTab & Err.Source & vbLf & "Number" & vbTab & vbTab & Err.Number & vbLf & "Description" & vbTab & Err.Description & vbLf & "DLL Error" & vbTab & Err.LastDLLError)
Return 2
End Try
End Function 'Main 
End Class 'MyProcess
